import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { createContext, useContext, useMemo, useEffect } from 'react';
import { inject } from 'mobx-react';
import { observer } from 'mobx-react-lite';
import { injectIntl } from 'react-intl';
import SelectDataSet from "./SelectDataSet";
import ProjectOptionsDataSet from "./ProjectOptionsDataSet";
var Store = /*#__PURE__*/createContext();
export function useSelectStore() {
  return useContext(Store);
}
export var StoreProvider = injectIntl(inject('AppState')(observer(function (props) {
  var _props$AppState = props.AppState,
      _props$AppState$curre = _props$AppState.currentMenuType,
      projectId = _props$AppState$curre.id,
      organizationId = _props$AppState$curre.organizationId,
      projectName = _props$AppState$curre.name,
      getUserId = _props$AppState.getUserId,
      formatMessage = props.intl.formatMessage,
      branchName = props.branchName,
      appServiceId = props.appServiceId,
      objectVersionNumber = props.objectVersionNumber,
      children = props.children,
      intlPrefix = props.intlPrefix,
      initIssues = props.initIssues;
  var projectOptionsDs = useMemo(function () {
    return new _DataSet(ProjectOptionsDataSet({
      organizationId: organizationId,
      userId: getUserId,
      projectId: projectId
    }));
  }, [organizationId]);
  var selectDs = useMemo(function () {
    return new _DataSet(SelectDataSet({
      projectId: projectId,
      formatMessage: formatMessage,
      appServiceId: appServiceId,
      objectVersionNumber: objectVersionNumber,
      branchName: branchName,
      projectOptionsDs: projectOptionsDs,
      initIssues: initIssues
    }), [projectId]);
  });
  useEffect(function () {
    if (initIssues && initIssues.length) {
      selectDs.loadData(initIssues);
    } else {
      selectDs.create();
    }
  }, [initIssues]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    prefixCls: 'c7ncd-branch-edit',
    appServiceId: appServiceId,
    selectDs: selectDs,
    formatMessage: formatMessage,
    intlPrefix: intlPrefix,
    projectOptionsDs: projectOptionsDs
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
})));